OGRE: Ogre::Animation Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::Animation Class Reference
Core » Animation

An animation sequence. More...

`#include <OgreAnimation.h>`

Inheritance diagram for Ogre::Animation:
[legend]

## Public Types
enum | InterpolationMode : uint8 { IM_LINEAR , IM_SPLINE }
| The types of animation interpolation available. More...
typedef ConstMapIterator< NodeTrackList > | NodeTrackIterator
typedef std::map< unsigned short, NodeAnimationTrack * > | NodeTrackList
typedef ConstMapIterator< NumericTrackList > | NumericTrackIterator
typedef std::map< unsigned short, NumericAnimationTrack * > | NumericTrackList
enum | RotationInterpolationMode : uint8 { RIM_LINEAR , RIM_SPHERICAL }
| The types of rotational interpolation available. More...
typedef std::set< ushort > | TrackHandleList
| A list of track handles.
typedef ConstMapIterator< VertexTrackList > | VertexTrackIterator
typedef std::map< unsigned short, VertexAnimationTrack * > | VertexTrackList

## Public Member Functions
| Animation (const String &name, Real length)
| You should not use this constructor directly, use the parent object such as Skeleton instead.
virtual | ~Animation ()
void | _applyBaseKeyFrame ()
| Internal method to adjust keyframes relative to a base keyframe (see setUseBaseKeyFrame).
void | _collectIdentityNodeTracks (TrackHandleList &tracks) const
| Internal method for collecting identity node tracks.
void | _destroyNodeTracks (const TrackHandleList &tracks)
| Internal method for destroy given node tracks.
const NodeTrackList & | _getNodeTrackList (void) const
| Fast access to NON-UPDATEABLE node track list.
const NumericTrackList & | _getNumericTrackList (void) const
| Fast access to NON-UPDATEABLE numeric track list.
TimeIndex | _getTimeIndex (Real timePos) const
| Internal method used to convert time position to time index object.
const VertexTrackList & | _getVertexTrackList (void) const
| Fast access to NON-UPDATEABLE Vertex track list.
void | _keyFrameListChanged (void)
| Internal method used to tell the animation that keyframe list has been changed, which may cause it to rebuild some internal data.
void | _notifyContainer (AnimationContainer *c)
void | apply (Entity *entity, Real timePos, Real weight, bool software, bool hardware)
| Applies all vertex tracks given a specific time point and weight to a given entity.
void | apply (Real timePos, Real weight=1.0, Real scale=1.0f)
| Applies an animation given a specific time point and weight.
void | apply (Skeleton *skeleton, Real timePos, float weight, const AnimationState::BoneBlendMask *blendMask, Real scale)
| Applies all node tracks given a specific time point and weight to a given skeleton.
void | apply (Skeleton *skeleton, Real timePos, Real weight=1.0, Real scale=1.0f)
| Applies all node tracks given a specific time point and weight to a given skeleton.
void | applyToAnimable (const AnimableValuePtr &anim, Real timePos, Real weight=1.0, Real scale=1.0f)
| Applies all numeric tracks given a specific time point and weight to the specified animable value.
void | applyToNode (Node *node, Real timePos, Real weight=1.0, Real scale=1.0f)
| Applies all node tracks given a specific time point and weight to the specified node.
void | applyToVertexData (VertexData *data, Real timePos, float weight=1.0)
| Applies all vertex tracks given a specific time point and weight to the specified vertex data.
Animation * | clone (const String &newName) const
| Clone this animation.
NodeAnimationTrack * | createNodeTrack (unsigned short handle)
| Creates a NodeAnimationTrack for animating a Node.
NodeAnimationTrack * | createNodeTrack (unsigned short handle, Node *node)
| Creates a new AnimationTrack automatically associated with a Node.
NumericAnimationTrack * | createNumericTrack (unsigned short handle, const AnimableValuePtr &anim)
| Creates a NumericAnimationTrack and associates it with an animable.
VertexAnimationTrack * | createVertexTrack (unsigned short handle, VertexAnimationType animType)
| Creates a VertexAnimationTrack for animating vertex position data.
VertexAnimationTrack * | createVertexTrack (unsigned short handle, VertexData *data, VertexAnimationType animType)
| Creates a VertexAnimationTrack and associates it with VertexData.
void | destroyAllNodeTracks (void)
| Removes and destroys all tracks making up this animation.
void | destroyAllNumericTracks (void)
| Removes and destroys all tracks making up this animation.
void | destroyAllTracks (void)
| Removes and destroys all tracks making up this animation.
void | destroyAllVertexTracks (void)
| Removes and destroys all tracks making up this animation.
void | destroyNodeTrack (unsigned short handle)
| Destroys the node track with the given handle.
void | destroyNumericTrack (unsigned short handle)
| Destroys the numeric track with the given handle.
void | destroyVertexTrack (unsigned short handle)
| Destroys the Vertex track with the given handle.
const String & | getBaseKeyFrameAnimationName () const
| If a base keyframe is being used, the Animation that provides that keyframe.
Real | getBaseKeyFrameTime () const
| If a base keyframe is being used, the time of that keyframe.
AnimationContainer * | getContainer ()
| Retrieve the container of this animation.
InterpolationMode | getInterpolationMode (void) const
| Gets the current interpolation mode of this animation.
Real | getLength (void) const
| Gets the total length of the animation.
const String & | getName (void) const
| Gets the name of this animation.
NodeAnimationTrack * | getNodeTrack (unsigned short handle) const
| Gets a node track by it's handle.
NodeTrackIterator | getNodeTrackIterator (void) const
NumericAnimationTrack * | getNumericTrack (unsigned short handle) const
| Gets a numeric track by it's handle.
NumericTrackIterator | getNumericTrackIterator (void) const
unsigned short | getNumNodeTracks (void) const
| Gets the number of NodeAnimationTrack objects contained in this animation.
unsigned short | getNumNumericTracks (void) const
| Gets the number of NumericAnimationTrack objects contained in this animation.
unsigned short | getNumVertexTracks (void) const
| Gets the number of VertexAnimationTrack objects contained in this animation.
RotationInterpolationMode | getRotationInterpolationMode (void) const
| Gets the current rotation interpolation mode of this animation.
bool | getUseBaseKeyFrame () const
| Whether a base keyframe is being used for this Animation.
VertexAnimationTrack * | getVertexTrack (unsigned short handle) const
| Gets a Vertex track by it's handle.
VertexTrackIterator | getVertexTrackIterator (void) const
bool | hasNodeTrack (unsigned short handle) const
| Does a track exist with the given handle?
bool | hasNumericTrack (unsigned short handle) const
| Does a track exist with the given handle?
bool | hasVertexTrack (unsigned short handle) const
| Does a track exist with the given handle?
void | optimise (bool discardIdentityNodeTracks=true)
| Optimise an animation by removing unnecessary tracks and keyframes.
void | setInterpolationMode (InterpolationMode im)
| Tells the animation how to interpolate between keyframes.
void | setLength (Real len)
| Sets the length of the animation.
void | setRotationInterpolationMode (RotationInterpolationMode im)
| Tells the animation how to interpolate rotations.
void | setUseBaseKeyFrame (bool useBaseKeyFrame, Real keyframeTime=0.0f, const String &baseAnimName=BLANKSTRING)
| Sets a base keyframe which for the skeletal / pose keyframes in this animation.

## Static Public Member Functions
static InterpolationMode | getDefaultInterpolationMode (void)
| Gets the default interpolation mode for all animations.
static RotationInterpolationMode | getDefaultRotationInterpolationMode (void)
| Gets the default rotation interpolation mode for all animations.
static void | setDefaultInterpolationMode (InterpolationMode im)
| Sets the default animation interpolation mode.
static void | setDefaultRotationInterpolationMode (RotationInterpolationMode im)
| Sets the default rotation interpolation mode.

## Detailed Description

An animation sequence.

This class defines the interface for a sequence of animation, whether that be animation of a mesh, a path along a spline, or possibly more than one type of animation in one. An animation is made up of many 'tracks', which are the more specific types of animation.

  You should not create these animations directly. They will be created via a parent object which owns the animation, e.g. Skeleton.

## Member Typedef Documentation

## ◆ NodeTrackList

typedef std::map<unsigned short, NodeAnimationTrack*> Ogre::Animation::NodeTrackList

## ◆ NodeTrackIterator

typedef ConstMapIterator<NodeTrackList> Ogre::Animation::NodeTrackIterator

## ◆ NumericTrackList

typedef std::map<unsigned short, NumericAnimationTrack*> Ogre::Animation::NumericTrackList

## ◆ NumericTrackIterator

typedef ConstMapIterator<NumericTrackList> Ogre::Animation::NumericTrackIterator

## ◆ VertexTrackList

typedef std::map<unsigned short, VertexAnimationTrack*> Ogre::Animation::VertexTrackList

## ◆ VertexTrackIterator

typedef ConstMapIterator<VertexTrackList> Ogre::Animation::VertexTrackIterator

## ◆ TrackHandleList

typedef std::set<ushort> Ogre::Animation::TrackHandleList

A list of track handles.

## Member Enumeration Documentation

## ◆ InterpolationMode

enum Ogre::Animation::InterpolationMode : uint8

The types of animation interpolation available.

Enumerator
IM_LINEAR | Values are interpolated along straight lines.
IM_SPLINE | Values are interpolated along a spline, resulting in smoother changes in direction.

## ◆ RotationInterpolationMode

enum Ogre::Animation::RotationInterpolationMode : uint8

The types of rotational interpolation available.

Enumerator
RIM_LINEAR | Values are interpolated linearly. This is faster but does not necessarily give a completely accurate result.
RIM_SPHERICAL | Values are interpolated spherically. This is more accurate but has a higher cost.

## Constructor & Destructor Documentation

## ◆ Animation()

Ogre::Animation::Animation | ( | const String & | name,
|  | Real | length )

You should not use this constructor directly, use the parent object such as Skeleton instead.

Parameters

  name | The name of the animation, should be unique within it's parent (e.g. Skeleton)
  length | The length of the animation in seconds.

Referenced by clone().

## ◆ ~Animation()

virtual Ogre::Animation::~Animation | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ getName()

const String & Ogre::Animation::getName | ( | void |  | ) | const

Gets the name of this animation.

## ◆ getLength()

Real Ogre::Animation::getLength | ( | void |  | ) | const

Gets the total length of the animation.

## ◆ setLength()

void Ogre::Animation::setLength | ( | Real | len | ) |

Sets the length of the animation.

Note
  Changing the length of an animation may invalidate existing AnimationState instances which will need to be recreated.

## ◆ createNodeTrack() [1/2]

NodeAnimationTrack * Ogre::Animation::createNodeTrack | ( | unsigned short | handle | ) |

Creates a NodeAnimationTrack for animating a Node.

Parameters

  handle | Handle to give the track, used for accessing the track later. Must be unique within this Animation.

## ◆ createVertexTrack() [1/2]

VertexAnimationTrack * Ogre::Animation::createVertexTrack | ( | unsigned short | handle,
|  | VertexAnimationType | animType )

Creates a VertexAnimationTrack for animating vertex position data.

Parameters

  handle | Handle to give the track, used for accessing the track later. Must be unique within this Animation, and is used to identify the target. For example when applied to a Mesh, the handle must reference the index of the geometry being modified; 0 for the shared geometry, and 1+ for SubMesh geometry with the same index-1.
  animType | Either morph or pose animation,

## ◆ createNodeTrack() [2/2]

NodeAnimationTrack * Ogre::Animation::createNodeTrack | ( | unsigned short | handle,
|  | Node * | node )

Creates a new AnimationTrack automatically associated with a Node.

This method creates a standard AnimationTrack, but also associates it with a target Node which will receive all keyframe effects.

Parameters

  handle | Numeric handle to give the track, used for accessing the track later. Must be unique within this Animation.
  node | A pointer to the Node object which will be affected by this track

## ◆ createNumericTrack()

NumericAnimationTrack * Ogre::Animation::createNumericTrack | ( | unsigned short | handle,
|  | const AnimableValuePtr & | anim )

Creates a NumericAnimationTrack and associates it with an animable.

Parameters

  handle | Handle to give the track, used for accessing the track later.
  anim | Animable object link Must be unique within this Animation.

## ◆ createVertexTrack() [2/2]

VertexAnimationTrack * Ogre::Animation::createVertexTrack | ( | unsigned short | handle,
|  | VertexData * | data,
|  | VertexAnimationType | animType )

Creates a VertexAnimationTrack and associates it with VertexData.

Parameters

  handle | Handle to give the track, used for accessing the track later.
  data | VertexData object link
  animType | The animation type Must be unique within this Animation.

## ◆ getNumNodeTracks()

unsigned short Ogre::Animation::getNumNodeTracks | ( | void |  | ) | const

Gets the number of NodeAnimationTrack objects contained in this animation.

## ◆ getNodeTrack()

NodeAnimationTrack * Ogre::Animation::getNodeTrack | ( | unsigned short | handle | ) | const

Gets a node track by it's handle.

## ◆ hasNodeTrack()

bool Ogre::Animation::hasNodeTrack | ( | unsigned short | handle | ) | const

Does a track exist with the given handle?

## ◆ getNumNumericTracks()

unsigned short Ogre::Animation::getNumNumericTracks | ( | void |  | ) | const

Gets the number of NumericAnimationTrack objects contained in this animation.

## ◆ getNumericTrack()

NumericAnimationTrack * Ogre::Animation::getNumericTrack | ( | unsigned short | handle | ) | const

Gets a numeric track by it's handle.

## ◆ hasNumericTrack()

bool Ogre::Animation::hasNumericTrack | ( | unsigned short | handle | ) | const

Does a track exist with the given handle?

## ◆ getNumVertexTracks()

unsigned short Ogre::Animation::getNumVertexTracks | ( | void |  | ) | const

Gets the number of VertexAnimationTrack objects contained in this animation.

## ◆ getVertexTrack()

VertexAnimationTrack * Ogre::Animation::getVertexTrack | ( | unsigned short | handle | ) | const

Gets a Vertex track by it's handle.

## ◆ hasVertexTrack()

bool Ogre::Animation::hasVertexTrack | ( | unsigned short | handle | ) | const

Does a track exist with the given handle?

## ◆ destroyNodeTrack()

void Ogre::Animation::destroyNodeTrack | ( | unsigned short | handle | ) |

Destroys the node track with the given handle.

## ◆ destroyNumericTrack()

void Ogre::Animation::destroyNumericTrack | ( | unsigned short | handle | ) |

Destroys the numeric track with the given handle.

## ◆ destroyVertexTrack()

void Ogre::Animation::destroyVertexTrack | ( | unsigned short | handle | ) |

Destroys the Vertex track with the given handle.

## ◆ destroyAllTracks()

void Ogre::Animation::destroyAllTracks | ( | void |  | ) |

Removes and destroys all tracks making up this animation.

## ◆ destroyAllNodeTracks()

void Ogre::Animation::destroyAllNodeTracks | ( | void |  | ) |

Removes and destroys all tracks making up this animation.

## ◆ destroyAllNumericTracks()

void Ogre::Animation::destroyAllNumericTracks | ( | void |  | ) |

Removes and destroys all tracks making up this animation.

## ◆ destroyAllVertexTracks()

void Ogre::Animation::destroyAllVertexTracks | ( | void |  | ) |

Removes and destroys all tracks making up this animation.

## ◆ apply() [1/4]

void Ogre::Animation::apply | ( | Real | timePos,
|  | Real | weight = 1.0,
|  | Real | scale = 1.0f )

Applies an animation given a specific time point and weight.

Where you have associated animation tracks with objects, you can easily apply an animation to those objects by calling this method.

Parameters

  timePos | The time position in the animation to apply.
  weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.
  scale | The scale to apply to translations and scalings, useful for adapting an animation to a different size target.

## ◆ applyToNode()

void Ogre::Animation::applyToNode | ( | Node * | node,
|  | Real | timePos,
|  | Real | weight = 1.0,
|  | Real | scale = 1.0f )

Applies all node tracks given a specific time point and weight to the specified node.

It does not consider the actual node tracks are attached to. As such, it resembles the apply method for a given skeleton (see below).

Parameters

  node |
  timePos | The time position in the animation to apply.
  weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.
  scale | The scale to apply to translations and scalings, useful for adapting an animation to a different size target.

## ◆ apply() [2/4]

void Ogre::Animation::apply | ( | Skeleton * | skeleton,
|  | Real | timePos,
|  | Real | weight = 1.0,
|  | Real | scale = 1.0f )

Applies all node tracks given a specific time point and weight to a given skeleton.

Where you have associated animation tracks with Node objects, you can easily apply an animation to those nodes by calling this method.

Parameters

  skeleton |
  timePos | The time position in the animation to apply.
  weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.
  scale | The scale to apply to translations and scalings, useful for adapting an animation to a different size target.

## ◆ apply() [3/4]

void Ogre::Animation::apply | ( | Skeleton * | skeleton,
|  | Real | timePos,
|  | float | weight,
|  | const AnimationState::BoneBlendMask * | blendMask,
|  | Real | scale )

Applies all node tracks given a specific time point and weight to a given skeleton.

Where you have associated animation tracks with Node objects, you can easily apply an animation to those nodes by calling this method.

Parameters

  skeleton |
  timePos | The time position in the animation to apply.
  weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.
  blendMask | The influence array defining additional per bone weights. These will be modulated with the weight factor.
  scale | The scale to apply to translations and scalings, useful for adapting an animation to a different size target.

## ◆ apply() [4/4]

void Ogre::Animation::apply | ( | Entity * | entity,
|  | Real | timePos,
|  | Real | weight,
|  | bool | software,
|  | bool | hardware )

Applies all vertex tracks given a specific time point and weight to a given entity.

Parameters

  entity | The Entity to which this animation should be applied
  timePos | The time position in the animation to apply.
  weight | The weight at which the animation should be applied (only affects pose animation)
  software | Whether to populate the software morph vertex data
  hardware | Whether to populate the hardware morph vertex data

## ◆ applyToAnimable()

void Ogre::Animation::applyToAnimable | ( | const AnimableValuePtr & | anim,
|  | Real | timePos,
|  | Real | weight = 1.0,
|  | Real | scale = 1.0f )

Applies all numeric tracks given a specific time point and weight to the specified animable value.

It does not applies to actual attached animable values but rather uses all tracks for a single animable value.

Parameters

  anim |
  timePos | The time position in the animation to apply.
  weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.
  scale | The scale to apply to translations and scalings, useful for adapting an animation to a different size target.

## ◆ applyToVertexData()

void Ogre::Animation::applyToVertexData | ( | VertexData * | data,
|  | Real | timePos,
|  | float | weight = 1.0 )

Applies all vertex tracks given a specific time point and weight to the specified vertex data.

It does not apply to the actual attached vertex data but rather uses all tracks for a given vertex data.

Parameters

  data |
  timePos | The time position in the animation to apply.
  weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.

## ◆ setInterpolationMode()

void Ogre::Animation::setInterpolationMode | ( | InterpolationMode | im | ) |

Tells the animation how to interpolate between keyframes.

By default, animations normally interpolate linearly between keyframes. This is fast, but when animations include quick changes in direction it can look a little unnatural because directions change instantly at keyframes. An alternative is to tell the animation to interpolate along a spline, which is more expensive in terms of calculation time, but looks smoother because major changes in direction are distributed around the keyframes rather than just at the keyframe.

  You can also change the default animation behaviour by calling Animation::setDefaultInterpolationMode.

## ◆ getInterpolationMode()

InterpolationMode Ogre::Animation::getInterpolationMode | ( | void |  | ) | const

Gets the current interpolation mode of this animation.

See setInterpolationMode for more info.

## ◆ setRotationInterpolationMode()

void Ogre::Animation::setRotationInterpolationMode | ( | RotationInterpolationMode | im | ) |

Tells the animation how to interpolate rotations.

By default, animations interpolate linearly between rotations. This is fast but not necessarily completely accurate. If you want more accurate interpolation, use spherical interpolation, but be aware that it will incur a higher cost.

  You can also change the default rotation behaviour by calling Animation::setDefaultRotationInterpolationMode.

## ◆ getRotationInterpolationMode()

RotationInterpolationMode Ogre::Animation::getRotationInterpolationMode | ( | void |  | ) | const

Gets the current rotation interpolation mode of this animation.

See setRotationInterpolationMode for more info.

## ◆ setDefaultInterpolationMode()

void Ogre::Animation::setDefaultInterpolationMode | ( | InterpolationMode | im | ) |
| static

Sets the default animation interpolation mode.

Every animation created after this option is set will have the new interpolation mode specified. You can also change the mode per animation by calling the setInterpolationMode method on the instance in question.

## ◆ getDefaultInterpolationMode()

InterpolationMode Ogre::Animation::getDefaultInterpolationMode | ( | void |  | ) |
| static

Gets the default interpolation mode for all animations.

## ◆ setDefaultRotationInterpolationMode()

void Ogre::Animation::setDefaultRotationInterpolationMode | ( | RotationInterpolationMode | im | ) |
| static

Sets the default rotation interpolation mode.

Every animation created after this option is set will have the new interpolation mode specified. You can also change the mode per animation by calling the setInterpolationMode method on the instance in question.

## ◆ getDefaultRotationInterpolationMode()

RotationInterpolationMode Ogre::Animation::getDefaultRotationInterpolationMode | ( | void |  | ) |
| static

Gets the default rotation interpolation mode for all animations.

## ◆ _getNodeTrackList()

const NodeTrackList & Ogre::Animation::_getNodeTrackList | ( | void |  | ) | const

Fast access to NON-UPDATEABLE node track list.

## ◆ getNodeTrackIterator()

NodeTrackIterator Ogre::Animation::getNodeTrackIterator | ( | void |  | ) | const
| inline

Deprecated
  use _getNodeTrackList

## ◆ _getNumericTrackList()

const NumericTrackList & Ogre::Animation::_getNumericTrackList | ( | void |  | ) | const

Fast access to NON-UPDATEABLE numeric track list.

## ◆ getNumericTrackIterator()

NumericTrackIterator Ogre::Animation::getNumericTrackIterator | ( | void |  | ) | const
| inline

Deprecated
  use _getNumericTrackList

## ◆ _getVertexTrackList()

const VertexTrackList & Ogre::Animation::_getVertexTrackList | ( | void |  | ) | const

Fast access to NON-UPDATEABLE Vertex track list.

Referenced by Ogre::Lod0Stripifier::StripLod0Vertices().

## ◆ getVertexTrackIterator()

VertexTrackIterator Ogre::Animation::getVertexTrackIterator | ( | void |  | ) | const
| inline

Deprecated
  use _getVertexTrackList

## ◆ optimise()

void Ogre::Animation::optimise | ( | bool | discardIdentityNodeTracks = true | ) |

Optimise an animation by removing unnecessary tracks and keyframes.

When you export an animation, it is possible that certain tracks have been keyframed but actually don't include anything useful - the keyframes include no transformation. These tracks can be completely eliminated from the animation and thus speed up the animation. In addition, if several keyframes in a row have the same value, then they are just adding overhead and can be removed.

Note
  Since track-less and identity track has difference behavior for accumulate animation blending if corresponding track presenting at other animation that is non-identity, and in normally this method didn't known about the situation of other animation, it can't deciding whether or not discards identity tracks. So there have a parameter allow you choose what you want, in case you aren't sure how to do that, you should use Skeleton::optimiseAllAnimations instead.

Parameters

  discardIdentityNodeTracks | If true, discard identity node tracks.

## ◆ _collectIdentityNodeTracks()

void Ogre::Animation::_collectIdentityNodeTracks | ( | TrackHandleList & | tracks | ) | const

Internal method for collecting identity node tracks.

This method remove non-identity node tracks form the track handle list.

Parameters

  tracks | A list of track handle of non-identity node tracks, where this method will remove non-identity node track handles.

## ◆ _destroyNodeTracks()

void Ogre::Animation::_destroyNodeTracks | ( | const TrackHandleList & | tracks | ) |

Internal method for destroy given node tracks.

## ◆ clone()

Animation * Ogre::Animation::clone | ( | const String & | newName | ) | const

Clone this animation.

Note
  The pointer returned from this method is the only one recorded, thus it is up to the caller to arrange for the deletion of this object.

References Animation(), and OGRE_NODISCARD.

## ◆ _keyFrameListChanged()

void Ogre::Animation::_keyFrameListChanged | ( | void |  | ) |
| inline

Internal method used to tell the animation that keyframe list has been changed, which may cause it to rebuild some internal data.

## ◆ _getTimeIndex()

TimeIndex Ogre::Animation::_getTimeIndex | ( | Real | timePos | ) | const

Internal method used to convert time position to time index object.

Note
  The time index returns by this function are associated with state of the animation object, if the animation object altered (e.g. create/remove keyframe or track), all related time index will invalidated.

Parameters

  timePos | The time position.

Returns
  The time index object which contains wrapped time position (in relation to the whole animation sequence) and lower bound index of global keyframe time list.

## ◆ setUseBaseKeyFrame()

void Ogre::Animation::setUseBaseKeyFrame | ( | bool | useBaseKeyFrame,
|  | Real | keyframeTime = 0.0f,
|  | const String & | baseAnimName = BLANKSTRING )

Sets a base keyframe which for the skeletal / pose keyframes in this animation.

Skeletal and pose animation keyframes are expressed as deltas from a given base state. By default, that is the binding setup of the skeleton, or the object space mesh positions for pose animation. However, sometimes it is useful for animators to create animations with a different starting pose, because that's more convenient, and the animation is designed to simply be added to the existing animation state and not globally averaged with other animations (this is always the case with pose animations, but is activated for skeletal animations via ANIMBLEND_CUMULATIVE).

  In order for this to work, the keyframes need to be 're-based' against this new starting state, for example by treating the first keyframe as the reference point (and therefore representing no change). This can be achieved by applying the inverse of this reference keyframe against all other keyframes. Since this fundamentally changes the animation, this method just marks the animation as requiring this rebase, which is performed at the next Animation::apply call. This is to allow the Animation to be re-saved with this flag set, but without having altered the keyframes yet, so no data is lost unintentionally. If you wish to save the animation after the adjustment has taken place, you can use _applyBaseKeyFrame

Parameters

  useBaseKeyFrame | Whether a base keyframe should be used
  keyframeTime | The time corresponding to the base keyframe, if any
  baseAnimName | Optionally a different base animation (must contain the same tracks)

References Ogre::BLANKSTRING.

## ◆ getUseBaseKeyFrame()

bool Ogre::Animation::getUseBaseKeyFrame | ( |  | ) | const

Whether a base keyframe is being used for this Animation.

## ◆ getBaseKeyFrameTime()

Real Ogre::Animation::getBaseKeyFrameTime | ( |  | ) | const

If a base keyframe is being used, the time of that keyframe.

## ◆ getBaseKeyFrameAnimationName()

const String & Ogre::Animation::getBaseKeyFrameAnimationName | ( |  | ) | const

If a base keyframe is being used, the Animation that provides that keyframe.

## ◆ _applyBaseKeyFrame()

void Ogre::Animation::_applyBaseKeyFrame | ( |  | ) |

Internal method to adjust keyframes relative to a base keyframe (see setUseBaseKeyFrame).

## ◆ _notifyContainer()

void Ogre::Animation::_notifyContainer | ( | AnimationContainer * | c | ) |

## ◆ getContainer()

AnimationContainer * Ogre::Animation::getContainer | ( |  | ) |

Retrieve the container of this animation.

The documentation for this class was generated from the following file:

- OgreAnimation.h